function actToJson(JSON) {
    try {
        JSON.signing = {};
        JSON.connection = {};
        if (JSON.identity !== undefined) {
            const appName = JSON.identity.appName;
            JSON.identity = {};
            JSON.identity.appName = appName;
        } else {
            JSON.identity = {}
        };
        JSON.identity.description = JSON.applicationProperties.description;
        JSON.identity.build = JSON.applicationProperties.build;
        JSON.identity.version = JSON.applicationProperties.version;
        JSON.signing.organization = JSON.publishingDetails.companyName;
        JSON.signing.developerID = JSON.publishingDetails.ownerID;
        JSON.signing.privateKeyPath = JSON.publishingDetails.privateKey;
        JSON.connection.hostIp = JSON.proxySetup.cloudUXServer;
        JSON.connection.hostPort = JSON.proxySetup.cloudUXPort;
        JSON.connection.proxyPort = JSON.proxySetup.localPort;
        delete JSON.applicationProperties;
        delete JSON.publishingDetails;
        delete JSON.proxySetup;
    }
    catch (error) {
        console.log('Adapter actToJdasdasdson problem ' + error);
    }
    return JSON;
}

function jsonToAct(JSON) {
    try {
        JSON.applicationProperties = {};
        JSON.publishingDetails = {};
        JSON.proxySetup = {};
        JSON.applicationProperties.description = JSON.identity.description;
        JSON.applicationProperties.build = JSON.identity.build;
        JSON.applicationProperties.version = JSON.identity.version;
        JSON.publishingDetails.companyName = JSON.signing.organization;
        JSON.publishingDetails.ownerID = JSON.signing.developerID;
        JSON.publishingDetails.privateKey = JSON.signing.privateKeyPath;
        JSON.proxySetup.cloudUXServer = JSON.connection.hostIp;
        JSON.proxySetup.cloudUXPort = JSON.connection.hostPort;
        JSON.proxySetup.localPort = JSON.connection.proxyPort;
        delete JSON.identity;
        delete JSON.signing;
        delete JSON.connection;
    }
    catch (error) {
        console.log(`Adapter jsonToAct problem ` + error);
    }
    return JSON;
}

function actToJsonServiceNode(JSON) {
    try {
        JSON.signing = {};
        JSON.connection = {};
        JSON.identity = {};
        JSON.identity.serviceName = JSON.applicationProperties.serviceName;
        JSON.identity.appID = JSON.applicationProperties.appID;
        JSON.identity.appSecret = JSON.applicationProperties.appSecret;
        JSON.identity.description = JSON.applicationProperties.description;
        JSON.identity.realm = JSON.applicationProperties.realm;
        JSON.identity.version = JSON.applicationProperties.version;
        JSON.identity.serviceID = JSON.applicationProperties.serviceID;
        JSON.identity.build = JSON.applicationProperties.build;
        JSON.signing.developerID = JSON.publishingDetails.ownerID;
        JSON.signing.organization = JSON.publishingDetails.companyName;
        JSON.signing.privateKeyPath = JSON.publishingDetails.privateKey
        JSON.connection.hostIp = JSON.proxySetup.cloudUXServer
        delete JSON.applicationProperties;
        delete JSON.publishingDetails;
        delete JSON.proxySetup;
    }
    catch (error) {
        console.log(`Adapter jsonToAct problem ` + error);
    }
    return JSON;
}

function jsonToActServiceNode(JSON) {
    try {
        JSON.applicationProperties = {};
        JSON.publishingDetails = {};
        JSON.proxySetup = {};
        JSON.applicationProperties.serviceName = JSON.identity.serviceName;
        JSON.applicationProperties.appID = JSON.identity.appID;
        JSON.applicationProperties.appSecret = JSON.identity.appSecret;
        JSON.applicationProperties.description = JSON.identity.description;
        JSON.applicationProperties.realm = JSON.identity.realm;
        JSON.applicationProperties.version = JSON.identity.version;
        JSON.applicationProperties.serviceID = JSON.identity.serviceID;
        JSON.applicationProperties.build = JSON.identity.build;
        JSON.publishingDetails.ownerID = JSON.signing.developerID;
        JSON.publishingDetails.companyName = JSON.signing.organization;
        JSON.publishingDetails.privateKey = JSON.signing.privateKeyPath;
        JSON.proxySetup.cloudUXServer = JSON.connection.hostIp;
        delete JSON.identity;
        delete JSON.signing;
        delete JSON.connection;
    }
    catch (error) {
        console.log(`Adapter jsonToAct problem ` + error);
    }
    return JSON;
}

module.exports = {
    jsonToAct,
    actToJson,
    actToJsonServiceNode,
    jsonToActServiceNode
}
